'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var useEventListener = require('../use-event-listener/use-event-listener.cjs.js');

const defaultOptions = {
    event: 'click'
};
const isBrowser = ()=>{
    return Boolean(typeof window !== 'undefined' && window.document && window.document.createElement);
};
const useClickAway = (listener, target, options = defaultOptions)=>{
    if (!isBrowser()) return;
    const onClick = (evt)=>{
        const element = vue.unref(target);
        if (element && !element.contains(evt.target)) {
            listener(evt);
        }
    };
    useEventListener.useEventListener(options.event, onClick, {
        target: document
    });
};

exports.useClickAway = useClickAway;
