'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');

const useState = (initial)=>{
    const state = vue.ref(initial);
    const dispatch = (next)=>{
        const draft = typeof next === 'function' ? next(state.value) : next;
        state.value = draft;
    };
    return [
        vue.readonly(state),
        dispatch
    ];
};

exports.useState = useState;
