'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var useState = require('../use-state/use-state.cjs.js');

const useTitle = (initialTitle = '')=>{
    const [title1, setTitle] = useState.useState(initialTitle);
    const titleChange = (title = '')=>setTitle(title);
    const setDocumentTitle = ()=>document.title = title1.value;
    const resetDocumentTitle = ()=>document.title = '';
    vue.onMounted(setDocumentTitle);
    vue.watch(title1, setDocumentTitle);
    vue.onBeforeUnmount(resetDocumentTitle);
    vue.onDeactivated(resetDocumentTitle);
    return {
        titleChange,
        title: title1
    };
};

exports.useTitle = useTitle;
