import { watch, unref, onMounted, onDeactivated, onBeforeUnmount } from 'vue';

function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var useEventListener = (event, listener, options = {})=>{
    const { target =window  } = options, rest = _objectWithoutProperties(options, [
        "target"
    ]);
    const remove = (el)=>{
        const _el = unref(el);
        _el && _el.removeEventListener(event, listener, rest);
    };
    const add = (el)=>{
        const _el = unref(el);
        _el && _el.addEventListener(event, listener, rest);
    };
    watch(()=>unref(target), (el, prevEl)=>{
        remove(prevEl);
        add(el);
    });
    onMounted(()=>add(target));
    onDeactivated(()=>remove(target));
    onBeforeUnmount(()=>remove(target));
};

export { useEventListener };
