import { onMounted, watch, onBeforeUnmount, onDeactivated } from 'vue';
import { useState } from '../use-state/use-state.esm.js';

const useTitle = (initialTitle = '')=>{
    const [title1, setTitle] = useState(initialTitle);
    const titleChange = (title = '')=>setTitle(title);
    const setDocumentTitle = ()=>document.title = title1.value;
    const resetDocumentTitle = ()=>document.title = '';
    onMounted(setDocumentTitle);
    watch(title1, setDocumentTitle);
    onBeforeUnmount(resetDocumentTitle);
    onDeactivated(resetDocumentTitle);
    return {
        titleChange,
        title: title1
    };
};

export { useTitle };
